-- billiards example, see TCS paper

-- hytech input file

define(vx,1)
define(vy,2)
define(xg,0)
define(yg,0)
define(xw,1)
define(yw,6)
define(leng,3)
define(ht,8)
define(period,24)

var
	x,
	y: analog;    -- coordinates of ball

automaton billiards
synclabs:;
initially northeast & x=xg & y = yg;

loc northeast: while 0 <=x& x<=leng & 0<=y& y<=ht wait {dx=vx,dy=vy}
  when x=leng goto northwest;
  when y=ht   goto southeast;

loc northwest: while 0<=x & x<=leng & 0<=y & y<=ht wait {dx=-vx,dy=vy}
  when x=0    goto northeast;
  when y=ht   goto southwest;

loc southeast: while 0<=x & x<=leng &0<=y &  y<=leng wait {dx=vx,dy=-vy}
  when x=leng goto southwest;
  when y=0    goto northeast;

loc southwest: while 0<=x & x<=leng & 0<=y & y<=ht wait {dx=-vx, dy=-vy}
  when x=0    goto southeast;
  when y=0    goto northwest;

end

var 
  at_white,
   init_at_grey,
  active, f_reached,
   reached: region;

at_white := x=xw & y=yw;
init_at_grey := x=xg & y=yg;

reached := reach backward from at_white endreach;

prints "All positions from which it is possible to reach the while ball";
print reached;


if empty(reached & init_at_grey)
  then 
    prints "Impossible to reach white ball from iniital position of grey ball";
  else
    prints "Can reach white ball from iniital position of grey ball";
endif;

