#include "include.h"
#include "basic.h"

extern int yylineno;

/* HWT control flags here */
int overflow_avoid_mode = FAST;

int poly_routine_id = 0; /* for identifying which routine we're in */

/*
  put global variables in here
*/
int rows, columns, matrix_id, tmp_index, cur_vec, sl1, 
    tmp_var_num, var_number, sync_number, loc_number, some_slope,
    tmp_var_count, trans_num, was_asap;
int last_n, last_d;
int sign;
int vect_len; 
int vector_id;
int DEFAULTS[5];
int n1,d1,n2,d2; /* for rationals, numerator and denominator */


int var_count = 0,  IN_SLOPE = 0;
int  SIMPLE_OUTPUT = 0;   /* set to 1 to get output, 0 for none */
int  HALB_OUTPUT = 0;     /* set to 1 to get output, 0 for none */
struct var_name * var_head = NULL, * syncs_head = NULL, * tmp_var_head;

struct _p_vector * vect_head = NULL, * vectors = NULL;

struct _p_matrix * matrix_head = NULL;
 
struct slope_entry * slope_info;


/* HWT: added 2/95 */
int init_matrix_id;  
char *init_location_name = NULL;

int infass[2];
/* give default dirn as post */
/* POST = 1 in enumerated type defn? */
int reach_dirn = 1;
int elim_all_locns = 0;
int elim_all_vars = 0; /* = 1 for non-parameters */
int had_dirn_spec = 0;
int had_elim_l_spec = 0;
int had_elim_v_spec = 0;
int had_final_spec = 0;
int elim_locs_by_list = 0;
int elim_vars_by_list = 0;
struct var_name *elim_proc_list = (struct var_name *) NULL;
struct var_name *elim_var_list = (struct var_name *) NULL;

int negated = 0; /* for use in slopelinearformulaas */

char *aut_name = NULL;

/* added HWT 10/19/95, for pre with new assignment constraint format */
/* int array, whether each var has been reassigned */
int *assgt_vars;

/* ======================================================= */

/* adding new variable to a list of variables */
void insert_var(name)
char * name;
{
  struct var_name * x = (struct var_name *)malloc(sizeof(struct var_name));
  if (-1 != var_index(name)) {
    char *errstr = (char *) malloc (strlen(name)+ 50);
    sprintf(errstr, "ERROR: duplicated variable declaration: %s\n", name);
    yyerrormessage(errstr);   
    exit(1);
    return;
    }
  x -> next = var_head;
  x -> name = (char *)malloc(sizeof(char) *(1 + strlen(name)));
  strcpy(x -> name, name);
  x -> index = var_number++;
  var_head = x;
}

/* adding new synclabel to a list of synclabels */
void insert_sync(name)
char * name;
{
  struct var_name * x = (struct var_name *)malloc(sizeof(struct var_name));
  if (-1 != var_index(name)) {
    char *errstr = (char *) malloc (strlen(name)+ 50);
    sprintf(errstr, "ERROR: duplicated sync label listing: %s\n", name);
    yyerrormessage(errstr);   
    exit(1);
    return;
    }
  x -> next = syncs_head;
  x -> name = (char *)malloc(sizeof(char) * (1 + strlen(name)));
  strcpy(x -> name, name);
  x -> index = sync_number++;
  syncs_head = x;
}

/* adding attributes to variables -- recall the grammar: attribute
   is specified AFTER the list of variables is given */
void add_attribute(attr)
int attr;
{
  struct var_name * x = var_head;
  for (; tmp_var_count; tmp_var_count--)
    { x -> attribute = attr; x = x -> next; }
}

/* mapping from ASCII names to indices --> later, list will be replaced
   by a table; however, the function calls will be unchanged */
int var_index(name)
char * name;
{
  struct var_name * x = var_head;
  for (; x; x = x -> next) if (!strcmp(x -> name, name)) return x -> index;
  return -1;
}

/* mapping from ASCII syncslabs names to indices */
int sync_index(name) 
char * name;
{
  struct var_name * x = syncs_head;

  for (; x; x = x -> next) if (!strcmp(x -> name, name)) return x -> index;
  return -1;
}


/* returning type of the specified variable */
int var_type(index)
int index;
{
  struct var_name * x = var_head;
  for (; x; x = x -> next) if (index == x->index) return x->attribute;
  printf("ERROR in var_type\n");
}

/* some of the procedures may seem duplicated - and in fact, they are;
   this is because I wanted to maintain C++ style using C -- so the
   functions (some of them) do not take arguments and the user is
   sure, that they operate on the correct data */
void free_var_list()
{
  struct var_name * x = var_head;

  for (; var_head; ) {
    x = var_head -> next;
    free(var_head -> name);
    free(var_head);
    var_head = x;
  }
  var_head = NULL;
}

void free_sync_list()
{
  struct var_name * x = syncs_head;

  for (; syncs_head; ) {
    x = syncs_head -> next;
    free(syncs_head -> name);
    free(syncs_head);
    syncs_head = x;
  }
  syncs_head = NULL;
}

/* vectors & matrices below */
void add_matrix()
{
  struct _p_matrix * m = (struct _p_matrix *)malloc(sizeof(struct _p_matrix));
  m -> next = matrix_head;
  matrix_head = m;
  matrix_head -> matrix_number = matrix_id;
  matrix_head -> rows = rows;
  matrix_head -> columns = columns;
  matrix_head -> vectors = vect_head;
  vect_head = NULL;
}

/* added HWT */
void
free_vec(x)
struct _p_vector *x; 
{
    free(x -> d);
    free(x -> n);
    free(x);
  }

void free_vect_list()
{
  struct _p_vector * x;
  for (; vect_head; ) {
    free(vect_head -> d);
    free(vect_head -> n);
    x = vect_head;
    vect_head = vect_head -> next;
    free(x);
  }
}



void free_vectors() { vect_head = vectors; free_vect_list(); vectors = NULL; }

void free_matrix_list()
{
  struct _p_matrix * x;
  for (; matrix_head; ) {
    free_vect_list();
    x = matrix_head;
    matrix_head = matrix_head -> next;
    free(x);
  }
  matrix_head = NULL;
}

struct _p_vector
*get_copy_of_vec(vec)
struct _p_vector *vec;
{
  int len;
  struct _p_vector * x = (struct _p_vector *)malloc(sizeof(struct _p_vector));
  x -> next = vec->next;
  x -> variable = vec->variable;
  x -> len =   vect_len = len = vec->len;
  x -> d = (int *)malloc(sizeof(int) * len);
  x -> n = (int *)malloc(sizeof(int) * len);
  x->vlcm = vec->vlcm;
 for (; len; ) { len--; x->d[len] = vec->d[len]; x->n[len] = vec->n[len];}
  return (x);
}

/* new_vect()  operates on vector pointed to by vect_head */
void new_vect(len)
int len;
{

  struct _p_vector * x = (struct _p_vector *)malloc(sizeof(struct _p_vector));
   /*printf(" new vector: len == %d; NULL(%d)\n", len, vect_head == NULL);*/
  x -> next = vect_head;
  vect_head = x;
  vect_head -> variable = -1; /* no-assignment */
  vect_head -> len = len;
  vect_head -> d = (int *)malloc(sizeof(int) * len);
  vect_head -> n = (int *)malloc(sizeof(int) * len);
  vect_head->vlcm = 0;
  vect_len = len;
  sign = 1;
 for (; len; ) { len--; vect_head->d[len] = 0; vect_head->n[len] = 0;}
}

/* below -- operations pertaining to 'while'/'when' sections */
/* this is the constant term (_free_?) */
/* modified 7/95. HWT to cope with >= 1 constant appearing in inequality */
void install_free_term_while()
{
  if (!vect_head) return;
  if ( vect_head -> n[vect_len - 1] == 0) {
    /* as before, assign the constant term */
    vect_head -> d[vect_len - 1] = last_d;
    vect_head -> n[vect_len - 1] = sign * last_n;
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    yywarningmessage("Constant term appears twice in inequality");
    vect_head->n[vect_len-1] =
      sign * last_n * vect_head->d[vect_len-1] + 
	     last_d * vect_head->n[vect_len-1];
    vect_head->d[vect_len-1] = vect_head->d[vect_len-1] * last_d;
  }
}

void install_coef_term_while(name)
char * name;
{
  int index = var_index(name);
  if (index == -1) {    
    char *errstr = (char *) malloc (strlen(name)+ 30);
    sprintf(errstr, " undeclared variable %s\n", name);
    yyerrormessage(errstr);
    exit(1);return; }
  if ( vect_head -> n[index] == 0) {
    /* as before, assign the constant term */
    vect_head -> d[index] = last_d;
    vect_head -> n[index] = sign * last_n;
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    char errstr[255];
    sprintf(errstr,"Variable %s appears twice in inequality",name);
    yywarningmessage(errstr);
    vect_head->n[index] =
      sign * last_n * vect_head->d[index] + 
	     last_d * vect_head->n[index];
    vect_head->d[index] = vect_head->d[index] * last_d;
  }

}

void install_coef1_term_while(name)
char * name;
{
  int index = var_index(name);
  if (index == -1) {
    char *errstr = (char *) malloc (strlen(name)+ 30);
    sprintf(errstr, " undeclared variable %s\n", name);
    yyerrormessage(errstr);
    exit(1);return; }
  if ( vect_head -> n[index] == 0) {
    /* as before, assign the constant term */
    vect_head -> d[index] = 1;
    vect_head -> n[index] = sign;
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    char errstr[255];
    sprintf(errstr,"Variable %s appears twice in inequality",name);
    yywarningmessage(errstr);
    vect_head->n[index] =
      sign *  vect_head->d[index] + 
	      vect_head->n[index];
  }
}

/* installing info for a primed variable */
void
install_coef_p_term(char *name) {
  int index;

  index = var_index(name);
  if (index == -1) { 
    char *errstr = (char *) malloc (strlen(name)+ 30);
    sprintf(errstr, " undeclared variable %s\n", name);
    yyerrormessage(errstr);
    exit(1); return; 
  }
/*  printf("Assigning 1 to assgt_vars[%d]\n", index-1); */
  assgt_vars[index-1] = 1;
  /* increment by number of variables, since a primed var */
  index += (var_number-1);
  if ( vect_head -> n[index] == 0) {
    /* as before, assign the constant term */
    vect_head -> d[index] = last_d;
    vect_head -> n[index] = sign * last_n;
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    char errstr[255];
    sprintf(errstr,"Variable %s appears twice in inequality",name);
    yywarningmessage(errstr);
    vect_head->n[index] =
      sign * last_n * vect_head->d[index] + 
	     last_d * vect_head->n[index];
    vect_head->d[index] = vect_head->d[index] * last_d;
  }
  
}

void
install_coef1_p_term(char *name) {
  int index;

  index = var_index(name);
  if (index == -1) { 
    char *errstr = (char *) malloc (strlen(name)+ 30);
    sprintf(errstr, " undeclared variable %s\n", name);
    yyerrormessage(errstr);
    exit(1);return; 
  }
/*   printf("Assigning 1 to assgt_vars[%d]\n", index-1); */
  assgt_vars[index-1] = 1;
  /* increment by number of variables, for primed var's index */
  index += (var_number-1);

  if ( vect_head -> n[index] == 0) {
    /* as before, assign the constant term */
    vect_head -> d[index] = 1;
    vect_head -> n[index] = sign;
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    char errstr[255];
    sprintf(errstr,"Variable %s appears twice in inequality",name);
    yywarningmessage(errstr);
    vect_head->n[index] =
      sign *  vect_head->d[index] + 
	      vect_head->n[index];
  }
}


void install_relop_while(optype)
int optype; 
{
  vect_head -> d[0] = optype;
  vect_head -> n[0] = optype;
}

/* HWT for new parser with linear inequalities, now treat in [l,u] as */
/* an inequality macro */
/* add two vectors, first assign the first vector, add it, create a new */
/* vector that differs only in the inequality type (optype) and bound */
void install_slope_bounds(lown,lowd,upn,upd)
int lown,
 lowd,
 upn,
 upd;
{
/* use sign == -1 everywhere since on RHS */
  struct _p_vector *copy_of_vect_head;
  struct _p_vector *bogus_vect_head;
  if (!vect_head) return;
  copy_of_vect_head = get_copy_of_vec(vect_head);
  if ( vect_head -> n[vect_len - 1] == 0) {
    /* as before, assign the constant term */
    vect_head -> d[vect_len - 1] = lowd;
    vect_head -> n[vect_len - 1] = -1 * lown; /* use sign == -1 since on RHS */
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    yywarningmessage("Constant term appears twice in inequality");
    vect_head->n[vect_len-1] =
      -1 * lown * vect_head->d[vect_len-1] + 
	     lowd * vect_head->n[vect_len-1];
    vect_head->d[vect_len-1] = vect_head->d[vect_len-1] * lowd;
  }
  /* install the lower bound vector */
  install_relop_while(GE);
  (void)vector_lcm();
   rows++; new_vect(1 + var_number);

  /* create upper bound vector from copy of vect head */
  if ( copy_of_vect_head -> n[vect_len - 1] == 0) {
    /* as before, assign the constant term */
    copy_of_vect_head -> d[vect_len - 1] = upd;
    copy_of_vect_head -> n[vect_len - 1] = -1 * upn;
  }
  else {
    /* must add the term last_n/last_d to value currently stored there */
    /* i assume the lcm is computed later, so i don't worry about it here */
    yywarningmessage("Constant term appears twice in inequality");
    copy_of_vect_head->n[vect_len-1] =
      -1 * upn * copy_of_vect_head->d[vect_len-1] + 
	     upd * copy_of_vect_head->n[vect_len-1];
    copy_of_vect_head->d[vect_len-1] = copy_of_vect_head->d[vect_len-1] * upd;
  }
  /* install the new term */
  copy_of_vect_head->next = vect_head->next;
  free_vec(vect_head);  
  vect_head = copy_of_vect_head;
  install_relop_while(LE);
  (void)vector_lcm();
}

/* add rows to vect_head  for each default slope */
void
install_default_slopes() {
  struct var_name *vn;
  vn = var_head;
  while (vn != NULL) {
    switch (vn->attribute) {
    case  V_PARAMETER: case V_DISCRETE:
      rows++; 
      new_vect(vect_len);
      install_relop_while(EQ);
      vect_head->n[vn->index] = vect_head->d[vn->index] = 1;
      break;
    case V_CLOCK:
      rows++;
      new_vect(vect_len);
      install_relop_while(EQ);
      vect_head->n[vn->index] = vect_head->d[vn->index] = 1;
      vect_head->n[vect_len-1] = -1;
      vect_head->d[vect_len-1] = 1;
      break;
    default: break;
    }
    vn = vn->next;
  }
}




/* some gcd/lcm operations; I use substraction instead of modulo --
   it seems to work better in most cases */
#define ABS(x) ( (x<0) ? (-x) : x)
/* greatest common divisor */
int gcd(x,y)
int x, y;
{
  int x1=x, y1=y;
  if (x == 0 || y == 0) return 1; /* most convenient */
  x = ABS(x); y = ABS(y);
  while (x != y)
    if (x > y) x = x - y;
    else       y = y - x;
  
  return x;
}

int lcm(x, y) 
{
  int tmp = gcd(x, y);

  return x * (y / tmp);
}

/* computes lcm of denominators and then multiplies entries by it */
/* after that -- only `1` in denominators of nonzero entries */
/* also, some corrections to fit into the required format */ 
/* operates on the vector pointed to by the vect_head     */
int vector_lcm()
{
  int x = 1, i, y;

  if (vect_head == NULL) return; /* in case of TRUE guard */
  for (i = 1; i <  vect_head -> len; i++)
    if (vect_head -> d[i] < 0)
      { vect_head -> d[i] *= -1; vect_head -> n[i] *= -1; }
/* 
if (IN_SLOPE) {
printf("VECTOR_LCM--> ");
for ( i = 1; i < vect_head -> len; i++)
  printf(" %d/%d ", vect_head->d[i], vect_head->n[i]);
  printf("\n");
}
*/
  if ((vect_head -> d[0] == LE) || (vect_head->d[0] == LT)){
    if (vect_head->d[0] == LE) {
      vect_head -> d[0] = GE;
      vect_head -> n[0] = GE;
    }
    else {
      vect_head->d[0] = vect_head->n[0] = GT;
    }
    for ( i = 1; i < vect_head -> len; i++)
      vect_head -> n[i] *= -1;
  }

  for ( i = 1; i < vect_head -> len; i++)
    if (vect_head -> d[i] != 0) {
      y = vect_head -> d[i];
      x = lcm(x, y);
    } else if (vect_head -> n[i] != 0)
         printf(" ERROR: %d/0\n",vect_head -> n[i]);

  for (i = 1; i < vect_head -> len; i++)
    if (vect_head -> d[i] != 0)
      { 
        vect_head -> n[i] *= x / vect_head -> d[i];
        vect_head -> d[i] = 1;
      }
/*
if (IN_SLOPE) {
printf("AFTER_VECTOR_LCM--> ");
for ( i = 1; i < vect_head -> len; i++)
  printf(" %d/%d ", vect_head->d[i], vect_head->n[i]);
  printf("\n");
}
*/
  return x;
}

void vect_clear()
{
  int i;
  for (i = 0; i < vect_head -> len; i++)
    vect_head -> d[i] = vect_head -> n[i] = 0;
}

/* creates last row in a matrix */
void add_last_vect()
{
  struct _p_vector * x;
  int i, len = var_number + 1;
  
  new_vect(var_number + 1);
  x = vect_head;  
  for (i = 1; i < var_number; i++) x->d[i]=x->n[i]=0;
  x->d[0]=x->n[0]=x->d[var_number]=x->n[var_number] = 1;
}

void transform_assignment(var_id)
int var_id; /* to which variable is this assignment ? */
{
   int lc;
   struct _p_vector * x = vect_head;

  /* HWT: 7/26/95. tighter error checking on assignments */
  if (var_type(var_id) == V_PARAMETER)  {
    yyerrormessage("Assignments to parameters are illegal.");
  }
  if (var_type(var_id) == V_DISCRETE) {
    if (! p_vector_eq(vect_head, vect_head->next) ) {
      yyerrormessage("Discrete variables cannot be assigned to intervals");
    }
  }


   /* why a for loop, isn't it only going to get the lower and upper bounds? */
   for (; vect_head; vect_head = vect_head -> next) {
     lc = vector_lcm();
     vect_head->d[0] = vect_head->n[0]=lc;  /* assignment */
     vect_head->variable = var_id;
   }
   x -> next -> next = vectors;
   vectors = x;
   vectors -> next -> vect_id = vector_id++;
   vectors -> vect_id = vector_id++;
}

/* ================================================== */

/* for new assgt format */

void
store_assgt() {
  int lc;
  struct _p_vector * x = vect_head;

  lc = vector_lcm();

  x -> next = vectors;
  vectors = x;
  vectors -> vect_id = vector_id++;
  /* so that it doesn't get accessed again directly, e.g. in free_vec_list() */
  vect_head = NULL;
}

/* managing & transforming slopes */

void free_slope_info()
{  
  free((*slope_info).min_d);
  free((*slope_info).min_n);
  free((*slope_info).max_d);
  free((*slope_info).max_n);
  free(slope_info); 
}

void clear_slopes()
{
  int i;
  for (i = 1; i < var_number; i++) 
    (*slope_info).min_d[i]=(*slope_info).min_n[i]=
    (*slope_info).max_d[i]=(*slope_info).max_n[i]=DEFAULTS[var_type(i)];
  (*slope_info).max_d[var_number]=(*slope_info).min_d[var_number]=1;
  (*slope_info).max_n[var_number]=(*slope_info).min_n[var_number]=0;

}


void slope_init()
{
   DEFAULTS[V_CLOCK] = 1;
   DEFAULTS[V_INTEGRATOR] = 0;
   DEFAULTS[V_PARAMETER] = 0;
   DEFAULTS[V_ANALOG] = 0;
   DEFAULTS[V_DISCRETE] = 0;
   slope_info = (struct slope_entry *)malloc(sizeof(struct slope_entry));
   (*slope_info).min_n = (int *)malloc(sizeof(int) * (var_number+1));
   (*slope_info).min_d = (int *)malloc(sizeof(int) * (var_number+1));
   (*slope_info).max_n = (int *)malloc(sizeof(int) * (var_number+1));
   (*slope_info).max_d = (int *)malloc(sizeof(int) * (var_number+1));
   clear_slopes();
/* HWT 2/17/95.  must get rays for slopes.  not lines. */

}

void insert_slope(index,n1,d1,n2,d2)
int index,n1,d1,n2,d2;
{
  int g1 = gcd(n1,d1), g2 = gcd(n2,d2);
  
  if (var_type(index) == V_CLOCK) 
    { yyerrormessage("Slope changes for clocks are illegal"); }
  if (var_type(index) == V_PARAMETER) 
    { yyerrormessage("Slope changes for parameters are illegal"); }
  if (var_type(index) == V_DISCRETE) 
    { yyerrormessage("Slope changes for discrete variables are illegal"); }
  if (var_type(index) == V_INTEGRATOR) 
    {
     if (   (n1*d2 != n2*d1)       /* n1/d1 != n2/d2 */
         || !(   (n1 == 0)         /* n1/d1 should be either 0 or 1 */
               || (n1 == d1) ) )
       {
	 yyerrormessage(
            "Slope changes for stopwatch variables must be 0 or 1"); 
       }
   }

  (*slope_info).min_n[index] = n1/g1;
  (*slope_info).min_d[index] = d1/g1;
  (*slope_info).max_n[index] = n2/g2;
  (*slope_info).max_d[index] = d2/g2;

}




/* old procedure for showing slopes 
void transform_slopes(len)
int len;
{
  int i;
  for (i = 1; i < var_number; i++)
    printf("var:%d' in [%d/%d,%d/%d]\n", i,
       (*slope_info).min_n[i],
  (*slope_info).min_d[i],
  (*slope_info).max_n[i],
  (*slope_info).max_d[i]);

}
*/

/* ============= HWT additions =========== */

/* changing functionality of slope declarations */
/* if no slope explicitly declared, then taken as arbitrary */
/*     previously there were default values for integrators, analog */
/*     as always, discrete vars have slope 0, and clocks 1, regardless */
/* set up a global index structure for whether a var's slopes have */
/*  been declared */
/* after all declarations of slopes, add slopes for the undeclared variables */


/* go and make the slopes with IDs in start_id, end_id inclusive, rays */
void
make_slopes_rays(int start_id, int end_id) {
/* assumes slopes in reverse order in vect_head */
   struct _p_vector * x = vectors;
  /* UNIMPLEMENTED --- go and change convert code 
     too , since the conversion was falsely done there, 
     now we really wnat some to be lines for unrestricted vars 
   */
   if (x->vect_id != end_id) {
     printf("***** Index mismatch in slope vectors\n");
     ansi_fflush(stdout);
   }
   else {
     while ((x != NULL) && (x->vect_id >= start_id)) {
       /* set bit to indicate it is a ray */
       x->n[0] = 1;
       x = x->next;
     }
   }
}


int *slope_declared = NULL;

void
clear_slope_decls() {
  int i;
  if (slope_declared == NULL) {
    slope_declared = (int *) malloc (var_count * sizeof(int));
  }
  for (i=0;i<var_count;i++) {
    /* check the type to decide this */
    if ((var_type(i+1) == V_CLOCK) || (var_type(i+1) == V_PARAMETER)
	|| (var_type(i+1) == V_DISCRETE)) {
      slope_declared[i] = 1;
    }
    else {
      slope_declared[i] = 0;
    }
  }

}

/* record  that the slope for var i (in 0..var_count) has been declared */
void
set_slope_declared(int i) {
  slope_declared[i-1] = 1;
}

void
add_for_undecl_slopes() {
/* add slope vectors for each variable with undeclared slope */
   int i,j;

   for (i=0;i<var_count;i++) {
     if (!slope_declared[i]) {
       /* add the vector to the list of slopes */
       /* creates a new vector, called vect_head */
       /* with next pointing to vectors */
       vect_head = NULL;
       new_vect(var_number+1);
       vect_head->vect_id=vector_id++;
       /* set most values to 0 */
       for (j=0;j<var_number+1;j++) {
	 vect_head->n[j] = 0;
       }
       /* set up increment in direction of var i only */
       /* 0'th entry used for eq. so i'th variable (i in [0..varcount-1]) */
       /*  should appear in pos i+1 */
       vect_head->n[i+1] = 1;
       /* set lcm to 1 */
       vect_head->vlcm = 1;
       vect_head->next = vectors;
       vectors = vect_head;
       vect_head = NULL;
     }
   }
   
}


/* store info for an assignment to a single term, rather than an interval */
/* modification of transform_assignment (3/95) */
/* just generate an extra vector, and use code for transform assignment */
/*  which will behave as if we parsed in x := [term,term] */
void transform_single_assignment(var_id)
int var_id; /* to which variable is this assignment ? */
{
  int i;
  struct _p_vector *x;
  /* generate an  extra vector, as if for the second term of an interval */
  new_vect(var_number+1);
  /* copy contents from next vector */
  /* using global vars vect_len and vect_head */
  x = vect_head->next;
  for (i=0;i<vect_len;i++) {
    vect_head->d[i] = x->d[i];
    vect_head->n[i] = x->n[i];
  }
  transform_assignment(var_id);
}

void
init_inf_ass_info() {
  infass[0]=0;
  infass[1]=0;
}

/* an infinite bound is denoted by a row of all zeros.   must set the */
/*   first elt to 0, since transform_assignment makes it lcm = 1 */
/* transform_assignment also transfers the vectors to the vector list, */
/*   and vect_head is lost */
void
fix_inf_ass_info() {
  if (infass[0]) {
    /*  stored in reverse order, so loweer ass is second on list */
    vectors->next->n[0]=0;
    
  }
  if (infass[1]) {
    /*  stored in reverse order, so upper ass at the head of list */
    vectors->n[0]=0;
  }
}

void
add_inf_ass() {
  /* essentially add the assignment, but keep the vector values 0 */
  new_vect(var_number+1);
}


void
add_pos_inf_ass() {
  infass[1]=1;
  add_inf_ass();
}


void
add_minus_inf_ass() {
  /* initialize start of assignment with emptying vect_head */
  vect_head = NULL;
  infass[0]=1;
  add_inf_ass();
}

/* set default structures ready for specification to be parsed in */
void
init_spec_info() {
#define false 0
  /* sets default to POSt? */
  reach_dirn = 1;
  elim_all_locns = false;
  elim_all_vars = false;
  had_dirn_spec = false;
  had_elim_l_spec = false;
  had_elim_v_spec = false;
  had_final_spec = false;
  elim_locs_by_list = false;
  elim_vars_by_list = false;
}

void
assign_pre_dirn() {
  /* PRE is enumerated type, stored as 0 in  enum directions */
  if (had_dirn_spec) {
    printf("Already declared a direction (%s), redecl ignored\n",
	   ((reach_dirn == 0) ? "PRE" : "POST") );
  }
  else {
   reach_dirn = 0;
   had_dirn_spec = 1;
 }
}

void
assign_post_dirn() {
  /* POST is enumerated type, stored as 1 in  enum directions */
  if (had_dirn_spec) {
    printf("Already declared a direction (%s), redecl ignored\n",
	   ((reach_dirn == 0) ? "PRE" : "POST") );
  }
  else {
   reach_dirn = 1;
   had_dirn_spec = 1;
 }
}

void
assign_elim_locns(int value) {
  if (had_elim_l_spec) {
    printf("Already declared locn elim info (%s), redecl ignored\n",
	   ((elim_all_locns == 0) ? "FALSE" : "TRUE") );
  }
  else {
   elim_all_locns = value;
   had_elim_l_spec = 1;
 }
}

void
assign_elim_vars(int value) {
  if (had_elim_v_spec) {
    printf("Already declared var elim info (%s), redecl ignored\n",
	   ((elim_all_vars == 0) ? "FALSE" : "TRUE") );
  }
  else {
   elim_all_vars = value;
   had_elim_v_spec = 1;
 }
}

/* place copy of the name in the global variable for automaton name */
void
store_automaton_name(char *name) {
  aut_name = str_preserve(name);
}


/* elimin proc. info stored in elim_proc_names as list of names of processes */
/* also, uses global boolean elim_locs_by_list to determine whether to use */
/* the list, or the boolean for elim_all_locns */
void
init_elim_locns() {
  elim_proc_list = (struct var_name *) NULL;
  elim_locs_by_list = 1; /* i.e. True */
}

/* add name to global list of names in elim_proc_names */
/* no check whether it is really a valid name or not */
void
add_elim_proc(char *procname) {
  struct var_name *x = (struct var_name *) malloc(sizeof(struct var_name));
  x->name = str_preserve(procname);
  x->next = elim_proc_list;
  elim_proc_list = x;
}


/* elimin var. info stored in elim_var_names as list of names of variables */
/* also, uses global boolean elim_vars_by_list to determine whether to use */
/* the list, or the boolean for elim_all_vars */
void
init_elim_vars() {
  elim_var_list = (struct var_name *) NULL;
  elim_vars_by_list = 1; /* i.e. True */
}

/* add name to global list of names in elim_proc_names */
/* no check whether it is really a valid name or not */
void
add_elim_var(char *varname) {
  struct var_name *x = (struct var_name *) malloc(sizeof(struct var_name));
  x->name = str_preserve(varname);
  x->next = elim_var_list;
  elim_var_list = x;
}


/* for error mesage, then exiting */
void
yyerrormessage(char *errorstr) {
  fprintf(stderr,"Error in input on line: %d\n",yylineno);
  fprintf(stderr,"\tAborting: %s\n\n",errorstr);
  exit(1);
}

void
yywarningmessage(char *warningstr) {
  fprintf(stderr, "Warning (line %d) : %s\n", yylineno, warningstr);
}



/* returns 0 if not equal, 1 if equal */
/* equality means exact same coefficients (n and d) */
/* i.e. ignore possibility of gcd's making them equivalent, etc, require */
/* exact syntactic equality */
int 
p_vector_eq(struct _p_vector *vec1, struct _p_vector *vec2) {
  int i;
  if (vec1->len != vec2->len) {
    return(0);
  }
  for (i=0;i<vec1->len;i++) {
    if (vec1->d[i] != vec2->d[i])
      return(0);
    if (vec1->n[i] != vec2->n[i])
      return(0);
  }
  return(1);
}

/* check that no fixed slope var names are used in slope constraints */
void check_slope_name(dvarname)
char *dvarname;
{
  char *varname;
  int index;

  if ((((int)strlen(dvarname))<2) || (dvarname[0] != 'd')) {
    char *errstr = (char *) malloc (strlen(dvarname)+ 50);
    sprintf(errstr, " illegal variable slope declarator %s\n", dvarname);
    yyerrormessage(errstr);
  }
    
  /* skip past the leading 'd' */
  varname = dvarname+1;
  index = var_index(varname);
  if (index == -1) { 
    char *errstr = (char *) malloc (strlen(varname)+ 30);
    sprintf(errstr, " undeclared variable %s\n", varname);
    yyerrormessage(errstr);
  }
  switch (var_type(index)) {
     case  V_PARAMETER: case V_DISCRETE:
    case V_CLOCK:
      fprintf(stderr,
              "Illegal use of fixed slope variable (%s) in slope constraints\n",
	      varname);
      ansi_fflush(stderr);
      exit(1);
      break;
    default: break;
    }

}

/* assume input is pointer to string with leading 'd' */
/* output: skip past the 'd' and pt to first char of var name */
char *
slope_name_of(char *dvarname) {
  return ( dvarname+1 );
}


