#include "location.h"

struct info_location *locations = NULL;
struct automata_list * automata = NULL;
int *assgt_vars = NULL;

void new_location(loc)
char * loc;
{
  struct info_location * new_loc = (struct info_location *)
                              malloc(sizeof(struct info_location));
/* **** must allow for copying the '\0' on end of string too */
  new_loc->location_name = (char *)malloc(sizeof(char) * strlen(loc)+1);
  strcpy(new_loc->location_name, loc);
  new_loc->next = locations;
  locations = new_loc;
  locations->transitions = NULL;
  locations->location_number=loc_number++;
}

int loc_index(name)
char * name;
{
  struct info_location * x = locations;
  for (; x; x = x -> next) 
    if (!strcmp(name, x->location_name)) return x->location_number;
  printf("LOCATION: %s undefined\n", name);
  return -1;
} 

void get_inv_id() { locations->matrix_inv_id = matrix_id; }
void get_guard_id() { locations->transitions->matrix_guard_id = matrix_id; }
/* added by HWT for initialization.  uses global var. init_matrix_id */
void get_init_matrix_id() {init_matrix_id = matrix_id; }
void store_init_loc_name(char *locname) {
   init_location_name = (char *) malloc ((strlen(locname) + 1) * sizeof(char));
   strcpy(init_location_name,locname);
 }


void get_slopvec()
{
  locations->slopes = slope_info;
  slope_init();
}

void new_transition()
{
  struct info_transition * new_tr =
     (struct info_transition *)malloc(sizeof(struct info_transition));

  new_tr -> transition_number = trans_num++;
  new_tr -> synlabel = NULL;
  new_tr -> next = locations -> transitions;
  locations -> transitions = new_tr;
  locations -> transitions -> assign = NULL;
}

/* auxilliary procedure for get_assignments() */
struct info_assign * old_ga(num, vptr)
int num;
struct _p_vector * vptr;
{
  struct info_assign * new_assign =
    (struct info_assign *)malloc(sizeof(struct info_assign));

  if (num==0) return NULL;
  
  new_assign -> next = ga(num - 2, vptr -> next -> next);
  if (vptr->variable != vptr->next->variable)
    printf("ERROR in get_assignments\n");
  new_assign -> var_id = vptr->variable;
  new_assign -> vect1 = vptr->next->vect_id;
  new_assign -> vect2 = vptr->vect_id;
  return new_assign;

}
  


/* auxilliary procedure for get_assignments() */
/* new version, only one vect per assignment constraint */
struct info_assign * ga(num, vptr)
int num;
struct _p_vector * vptr;
{
  struct info_assign * new_assign =
    (struct info_assign *)malloc(sizeof(struct info_assign));

  if (num==0) return NULL;
  
  new_assign -> next = ga(num - 1, vptr -> next);
  new_assign -> var_id = vptr->variable;
  new_assign -> vect1 = vptr->vect_id;
  return new_assign;

}


void get_assignments(num)
int num;
{
  locations->transitions->assign = ga(num, vectors);
  locations->transitions->ass_vars = assgt_vars;
/*  print_array(assgt_vars,var_count); */
}   

void get_destination(dest)
char * dest;
{
/* **** need to allow for ending '\0' */
  locations -> transitions -> destination =
    (char *)malloc(strlen(dest)+1);
  strcpy(locations -> transitions -> destination, dest);
}

void get_synlabel(synlab)
char * synlab;
{
/* **** need to allow for ending '\0' */
  locations -> transitions -> synlabel =
    (char *)malloc(strlen(synlab)+1);
  strcpy(locations -> transitions -> synlabel, synlab);
}

int new_slope_vectors;

/* auxilliary for produce_slop_vectors */
void psv(step, max, v)
int step, max;
struct _p_vector * v;
{
  int j, i = step;
  struct _p_vector * n = NULL;

  if (step > max) return;
  if (locations->slopes->min_n[i]*locations->slopes->max_d[i]!=
      locations->slopes->max_n[i]*locations->slopes->min_d[i])
    /* different slops */
    { 
      new_slope_vectors++; 
      new_vect(var_number + 1);
/* for slope vectors we want first entry to be 1 */
/* HWT 2/17/95 */
/* next line is mine */
  vect_head->n[0] = 1;


      vect_head->vect_id=vector_id++;
      n = vect_head;
      for(j = 1; j < i; j++) {vect_head->n[j]=v->n[j];vect_head->d[j]=v->d[j];}
      vect_head->n[i]=locations->slopes->max_n[i];
      vect_head->d[i]=locations->slopes->max_d[i];
    }
  v->n[i]=locations->slopes->min_n[i];
  v->d[i]=locations->slopes->min_d[i];
  psv(step + 1, max, v);
  if (n != NULL) psv(step + 1, max, n);
}

void produce_slope_vectors()
{
  struct _p_vector * n;
  int i; 
  int this_lcm;

  vect_head = NULL;
  new_slope_vectors = 1;
  new_vect(var_number + 1);
  vect_head->vect_id=vector_id++;
  psv(1, var_number, vect_head);
  n = vect_head;
  IN_SLOPE = 1;
  for (i = 0; i < new_slope_vectors; i++) {
    /* was (void)vector_lcm(); -- changed 3/1/95 HWT */
    vect_head->vlcm = vector_lcm();
    if (i + 1 != new_slope_vectors) vect_head = vect_head -> next;
  }
  IN_SLOPE = 0;
  vect_head -> next = vectors;
  vectors = n;
  vect_head=NULL;
}

/* called after each automaton is made */
/* create a new link to store the info from recently found automaton */
void new_automaton()
{
  struct automata_list * a = 
    (struct automata_list *)malloc(sizeof(struct automata_list));

  
  /* automata is initially null? */
  a->next=automata;
  automata=a;
  a->vectors=vectors;
  a->matrices=matrix_head;
  a->locations=locations;

  /* added by HWT */
  a->init_loc_name = init_location_name;
  a->init_m_id = init_matrix_id;
  a->nr_event_labels = sync_number-1;
  a->event_labels = syncs_head;
  a->automaton_name = aut_name;

  vectors=NULL;
  vect_head=NULL;
  matrix_head=NULL;
  locations=NULL;

/* add these initializations */
/* are there others missing?? */
  vector_id = loc_number = trans_num = 0;
}


/* FOR HALB *************************/
/* some more functions for locations */

/* get invariant guard of the given location */
int get_loc_invariant(loc_n)
int loc_n;
{
  struct info_location * x = locations;

  for (; x; x = x -> next) if (loc_n = x->location_number) 
    return x->matrix_inv_id;
  return -1;
}


#define MAX_TRANS_IN 200


/* returns the vector of transitions to the given location */
int *  transitions_to(loc_n)
int loc_n;
{
  struct info_location * x = locations;
  struct info_transition * y;
/* **** how do you know loc_n is enough room for all the in_trans */
/* there may well be an unlimited number of transitions into any */
/* given locn */
/* was ... */
/*  int i = 0, * in_trans = (int *)malloc(sizeof(int) * loc_n); */

/* changed to */
/* for some reason, initial value is ignored? */
  int i = 0, * in_trans_ptr;
  int in_trans[ MAX_TRANS_IN];
  int j;

  for (; x; x = x -> next)
    for (y = x->transitions; y; y = y->next)
      if (loc_index(y->destination) == loc_n){
	if (i >= MAX_TRANS_IN) { 
	  printf("Overflowing allowed memory in transitions_to\n");
	  exit(1);
	}
	else {
	  in_trans[i] = y->transition_number;
	  i++;
	}
      } 
  in_trans[i] = -1;
  in_trans_ptr = (int *)malloc(sizeof(int) * (i+1));
  for (j=0;j<=i;j++) {
    in_trans_ptr[j] = in_trans[j];
  }

  return in_trans_ptr;
}



/* added HWT 10/19/95 */
/* operates on global var assgt_vars, an int array of whether each
      var has been reassigned 
   sets the array to all zeroes
*/
void
set_assgt_vars_empty() {
  int i;
  assgt_vars = (int *) malloc(var_count * sizeof(int));
  clear_int_array(assgt_vars,var_count);
}
