#include "output.h"



int ONE = 1, last_loc = 0;

void Hprint_vars(x)
struct var_name * x;
{
  if (!x) return;
  Hprint_vars(x -> next);
  printf(" %s", x -> name, x-> index);
}

void Hprint_var_names() 
{ printf("names: ["); Hprint_vars(var_head); printf(" ]\n"); }

int printing_vectors = 0;

/* printing vectors in reverse order */
void Hpw(x)
struct _p_vector * x;
{
  int i;
  if (x == NULL) return;
  Hpw(x -> next);
  if (!matrix_print) printf("%d: (%d) ", x->vect_id, columns/*, x->variable*/);

  printf("[");
  for (i = 0; i < x -> len; i++) 
    printf("%3d  ", x -> n[i]);
  printf("]\n");
}

void Hprint_vect()
{
  printf("%d (%d,%d)\n", matrix_id, rows, columns);
  Hpw(vect_head);

}

void Hprint_vectors()
{
  printf("vectors: %d\n", vector_id);
  printing_vectors = 1;
  Hpw(vectors);
  printing_vectors = 0;
}

/* print matrices in reverse order */
void Hpm(x)
struct _p_matrix * x;
{
  if (!x) return;
  Hpm(x -> next);
  printf("%d: (%d, %d) [\n", x->matrix_number, x->rows,x->columns);
  matrix_print = 1;
  Hpw(x -> vectors);
  matrix_print = 0;
  printf("]\n");
}

void Hprint_matrices()
{
  printf("matrices: %d\n", matrix_id + 1);
  pm(matrix_head);
}

/* continuous phase transitions within a location */
void aux1(slop_num, last_slop_num, loc_n)
int slop_num, last_slop_num, loc_n;
{
  printf("X(%d)", slop_num);
  if (slop_num < last_slop_num) 
    { printf("("); aux1(slop_num + 1, last_slop_num, loc_n); printf(")"); }
  else printf("(P%d)", loc_n + ONE);
}
  
void Hprint_cptwl_info(l)
struct info_location * l;
{
  if (!l) return;
  Hprint_cptwl_info(l->next);
  if (l->slop_start_vect == l->slop_end_vect + 1) /* no slopes */
    printf("P%d = I(P%d,C%d)\n",ONE+loc_number+l->location_number,
                                ONE+l->location_number,l->matrix_inv_id);
    else { printf("P%d = I(", ONE+loc_number + l->location_number);
           aux1(l->slop_start_vect, l->slop_end_vect,l->location_number);
           printf(",C%d)\n",l->matrix_inv_id);
         }
}

/* compute post-images of transitions */
void aux3(a, loc_n, m_guard_id)
struct info_assign * a;
int loc_n, m_guard_id;
{
  if (a) {
    printf("S(%d,%d)(", a->var_id, a->vect1);
    aux3(a->next, loc_n, m_guard_id);
    printf(")");
  } else printf("I(P%d,C%d)",ONE+loc_number + loc_n, m_guard_id);
}

void aux2(loc_n,t)
int loc_n;
struct info_transition * t;
{
 
  struct info_assign * a = t->assign;
  int dest = loc_index(t->destination) , dest_inv;  
  int m_guard_id = t-> matrix_guard_id;
  struct info_location * l = locations;

  
  if (!t) return;
  if (t->next) aux2(loc_n,t->next);
  for (; l ; l = l->next) 
    if (l->location_number == dest) { dest_inv = l->matrix_inv_id; break; }

  printf("P%d = I(",ONE+t->transition_number+2*loc_number);
  aux3(a, loc_n, m_guard_id);
  printf(",C%d)\n", dest_inv);
}
  
  

void Hprint_pit_info()
{
struct info_location * l = locations;
  for (; l; l = l -> next) {
    if (l->transitions) aux2(l->location_number,l->transitions);
  }
        
}

/* accumulate post-images */
void aux4(i, in_trans, loc_n)
int i, * in_trans, loc_n;
{
  printf("U(P%d,",ONE+2*loc_number + in_trans[i]);
  if (in_trans[i+1] == -1) printf("P%d)", ONE+loc_number + loc_n);
  else { aux4(i + 1, in_trans, loc_n); printf(")"); }
}

void Hprint_api_info()
{
  struct info_location * l = locations;
  int * in_trans, i, ln;

  for (; l; l = l->next)
    {
      ln = l->location_number;
      in_trans = transitions_to(l->location_number);
      if (in_trans[0] != -1)
        { printf("P%d = ",ONE+ln); aux4(0, in_trans, ln); }
      free(in_trans);
      printf("\n");
    }
}

void Hpolyhedra_info()
{ 
  int i, polys = 2*(loc_number-last_loc) + trans_num;

  printf("polyhedra: %d\n", polys);
  for (i = 0; i < polys + (ONE == 1) ; i++) 
    printf("E(P%d,%d)\n", i+ONE, var_number + 1);
  if (ONE == 1) printf("\nP0 = C0\n\n[\n");
  else printf("[\n");
  Hprint_cptwl_info(locations);
  printf("\n\n");
  Hprint_pit_info();         
  printf("\n\n");
  Hprint_api_info();
  printf("\n\n");
  printf("]\n");
  ONE += polys + (ONE == 1); 
  last_loc = loc_number;
}

