//
// verification routines
// 
//



#include "verif.H"

polyhedron *
zero_poly_p(int nrvars) {
  int v;   // variable index
  int i;
  // gives matrix constraint form
cout << "making zero poly with " << nrvars << " vars \n";
  matrix zm = matrix(nrvars+1,nrvars+2);
  for (v=0;v<nrvars;v++) {
    // first col = 0 for equality
    zm.p[v][0] = 0;
    for (i=0;i<nrvars;i++) { 
      zm.p[v][i+1] = 0;
    }
    zm.p[v][v+1] = 1;
    // the constant
    zm.p[v][nrvars+1] = 0;
  }
  // last row
  zm.p[nrvars][0] = zm.p[nrvars][nrvars+1] = 1;
  for (i=0;i<nrvars;i++) {
    zm.p[nrvars][i+1] = 0;
  }
  polyhedron *pp = new polyhedron(zm,true);
  return(pp);
}


// yields whether this str is name for location with gate component not up
Bool
gate_not_up(char *str) {
  return ( strstr(str,".up.") == NULL );
}


//
// test whether utility property is satisfied for this list of reached regions
void
test_util(region **allreached, automaton *thisaut) {
  int i,j;
  Bool violating = false;
  // (states where x1[x2] <= -22 & y1[y2]>=11)
  matrix badstatematrix = matrix(5,var_count+2);
  for (i=0;i<5;i++) {
    badstatematrix.p[i][0] = 1;
    for (j=1;j<var_count+1;j++) {
      badstatematrix.p[i][j] = 0;
    }
  }
  // x1 <= -22
  badstatematrix.p[0][1] = -1;
  badstatematrix.p[0][var_count+1] = -22;
 // x2 <= -22
  badstatematrix.p[1][3] = -1;
  badstatematrix.p[1][var_count+1] = -22;
  // y1 >= 11
  badstatematrix.p[2][2] = 1;
  badstatematrix.p[2][var_count+1] = -11;
  // y2 >= 11
  badstatematrix.p[3][4] = 1;
  badstatematrix.p[3][var_count+1] = -11;
  // final row
  badstatematrix.p[4][0] =  badstatematrix.p[4][var_count+1] = 1;
  
  // make a poly using the constraint matrix
  polyhedron badstates = polyhedron(badstatematrix,true);
  cout << "The BAD STATES are: \n";
  badstates.print();
  cout << "End BAD STATES \n";
  for (i=0;i<thisaut->nr_locations;i++) {
    // check to see if the list of regions contains violations
    if (gate_not_up(thisaut->locations[i].name)) {
      // must check for bad regions (states where x1[x2] <= -22 & y1[y2]>=11)
      region *regp = allreached[i];
      cout << "testing for locn :" << thisaut->locations[i].name << "\n";
      while (regp!= NULL) {
	region *r = regp->intersect(&badstates);
	if (!r->is_empty()) {
	  cout << "Utility violated\n";
	  r->print();
	  violating = true;
	}
	regp = regp->next;
      }
    }
  } 
  cout << "Result of test (violating =) : " << Bool_output(violating) << 
    "\n" << flush;
}


void
test_reached_set(region_array *allreached) {
  region_array *rap;
  region *rp;
  if (elim_all_vars) {
    cout << "About to attempt eliminating all with string 'error' \n" << flush;
    rap = allreached->eliminate_non_params();
  }
  else {
    rap = allreached;
  }


//  cout << "After eliminating  nonparams, here is the list:\n" << flush;
//  rap->print();
//  cout << "end list\n";
   rap->simplify();
//  cout << "After simplifying, here is the list:\n" << flush;
//  rap->print();
//  cout << "end list\n";

  if (elim_all_locns) {
    rp = rap->eliminate_locations_with_str("");
  }
  else {
    rp = rap->eliminate_locations_with_str("error");
  }
  cout << "Here's the simplified string\n";
  if (rp != NULL) {
    rp->print();
  }
  cout << "End of simplification\n";
}





// perform extremely naive forward reachability.  Just to check 
// things are going correctly.
// 
// later return the reached list.
//
// dir is either PRE or POST (start from initial either way for now)
// 
void
automaton::simple_reachability(int dir) {
// 
// maintain an array of linked lists of regions.
//
// algo.  given initial region (which is that?) perform reachability on each
// list of newly reachable regions, and for each check containment in others
// 
  int i;
  Bool done = false;
  region **reached; // beware. indexing is such that reached[5] has regions
                    // with locn_id 5.
  region *active = NULL;
  region *init_active;
  reached = (region **) malloc (nr_locations * sizeof( region *));
  cout << "***************************************************\n";
  cout << "Simple reachability under test\n" << flush;
  for (i=0;i<nr_locations;i++) {
    reached[i] = NULL;
  }
  // second param is how many extra var to allow for. assume worst case is all.
  make_exist_vectors(var_count,var_count);

  // add the initial region to the reached array
  //   and to the active list
  // assume for now that the initial region is given by the first location
  //   (last id)
  //   and pt (0,0, ..,0) 

  init_active = new region();
  // this is location of initial region?
  init_active->locnp = init_location_p;
  // previously was &locations[nr_locations-1] and zero_poly_p(var_count);
  init_active->polyp = new polyhedron(*init_region_p,true);
  init_active->next = NULL;
  active = init_active->cts_evolve(POST);
  cout << "Starting from (after cts evolve)\n";
  active->print();
  cout << flush;

  reached[active->locnp->locn_id] = active->fresh_copy();

  while (!done) {
    region *regp = active;
    region *succp = NULL;   // list of successor regions from regp
    region *sp = NULL;      // index ptr through succp
    region *new_succ = NULL; // list of successors that are new
    // assume done until get a new region
    done = true;


cout << "33333333333333333333333333\n";
cout << "USING THIS new ACTIVE LIST \n";
cout << "33333333333333333333333333\n";
regp->print();
cout << "44444444444444444444444444\n";

    while (regp != NULL) {
      // for each element of the active list find successor list

#ifdef DEBUG_VERIF
 cout << "finding succ from: \n" << flush;
 regp->print(); cout << " End find list\n\n" << flush;
#endif
       if (dir == PRE) {
	 succp = regp->pre();
       } 
       else {
	 succp = regp->post();
       }
#ifdef DEBUG_VERIF
 cout << " ----------------- found these successors -----\n";
 if (succp!= NULL)
   succp->print();
 cout << " ----------------- end these successors -----\n";
#endif

// create new procedure to do this.
// 

      sp = succp;
      while (sp != NULL) {
	region *existp;   // for traversing existing regions
	Bool processed;   // whether handled this region yet.
	Bool new_reg;     // whether a new region that needs to be explored
	// merge each successor with currently reached.
#ifdef DEBUG_VERIF
cout << "testing whether to add this successor\n"; sp->print(); cout << flush;
#endif
	existp = reached[sp->locnp->locn_id];
#ifdef DEBUG_VERIF
cout << "existing list for this location is\n"; if (existp != NULL) existp->print();
#endif
	processed = false;
	new_reg = false;
	while (!processed && (existp!= NULL)) {
	  // test for containment
	  if (sp->is_contained_in(*existp)) {
	    processed = true;
	  }
//	  else {
//	    if (existp->is_contained_in(*sp)) {
	      // contained in but not equal, since we tested earlier
	      // for efficiency we should remove the smaller one.
	      // replace with larger.  this can't infinitely recurse.
	      // however failure to remove the old one is disastrous.
	      // for now, simply check for containment
//	      processed = true;
//	      new_reg = true;
//            cout << "second test\n";
//	    }
//	}
	  existp = existp->next;
	} // while for checking existing regions
	if (! processed  || (processed && new_reg)) {
	  // put any "new" successor regions in new active list
	  // and in reached list
	  done = false;
#ifdef DEBUG_VERIF
	  cout << "it's a new region\n";
#endif
	  if ( reached[sp->locnp->locn_id] != NULL) {
	    reached[sp->locnp->locn_id]= 
	      reached[sp->locnp->locn_id]->insert(new region(*sp));
	  }
	  else {
	    reached[sp->locnp->locn_id]= new region(*sp);
	  }
	  if (new_succ == NULL) {
	    new_succ = new region(*sp);
	  }
	  else {
	    new_succ = new_succ->insert( new region(*sp) );
	  }
	}
	else {
	  // otherwise if not new_ref, then free memory.
	  // no. free all at end

	}
	sp = sp->next;


      } // end while loop through succ list
	// free the entire succ list // unimplemented	
      regp= regp->next;
    } // end of passing through old active list
    // free the active list. but not the data they pt to.
// unimplemented

    // assign new active list 
    active = new_succ;
  } // end of fixpoint
  cout << "***************************************************\n";
  cout << "Simple output of reachable regions only!! \n" << flush;
  for (i=0;i<nr_locations;i++) {
    if (reached[i] != NULL) {
      reached[i]->print();
    }
  }

// temporary test for GRC spec (util)
//  test_util(reached,this);
  region_array ra;
  ra.size = nr_locations; 
  ra.regions = reached;
  test_reached_set(&ra);

  global_free(reached);
}

region_array*
automaton::new_reach(enum directions dirn) {
//   in either case start with the "initial" region.
  region_array *initra = init_region_array(this,dirn);
  region_array *allreached = initra->ra_reach(dirn);
//  cout << "After call to reach from initial region\n" << flush;
//  allreached->print();

// temporarily here, until figure out how to return a region_array*
// test_reached_set(allreached);

  return(allreached);
}



